
%ROD_ani 
%   Detailed explanation goes here

clear;

invert=0;
outfile='ani.h';
floodfill=[0];

sizecoef=1.0;

tresh=128;

img=imread('rod_gif/pacman.gif','frames','all');
img=img(:,:,1, : );
mx=max(max(max(max(img))));
img=uint8(double(img).*double(255./mx));    %normalise to 255
img=img>tresh;

hei=size(img, 1)/2;
wid=size(img, 2)/2;
siz=min(hei, wid);
frames=size(img,4);

%rect=1;
rect=(siz/128);
rectd=(siz/64);
%if (rect==0) rect=1; end
%if (rectd==0) rectd=1; end



fid1 = fopen( outfile, 'w' );

fprintf (fid1, ['#define A_FRAMES ' int2str(frames) '\n']);
fprintf (fid1, 'prog_uint16_t ani0[A_FRAMES][256]={\n');

% errors

img(37,4,1,2)=1;

% floodfill
if (floodfill(1,1))
    for f=1:frames
        img(:,:,1,f)=imfill(img(:,:,1,f),floodfill);
    end
end


% convert frames 
out=ones([256, 16, 1, frames]);
tstsize=max(size(img));
test=ones([tstsize, tstsize, 1, frames]);

for f=1:frames
    fprintf (fid1, '{\n');
    for i=0:255
            xm=( siz*(sizecoef*cos(2*pi*i/256)));
            ym=( siz*(sizecoef*sin(2*pi*i/256)));
        for j=0:15
            x=round(wid+xm*(j+.50)/16);
            y=round(hei+ym*(j+.50)/16);

            xr=round(tstsize/2+xm*(j+.50)/16);
            yr=round(tstsize/2+ym*(j+.50)/16);
            
            xl=round(x-rect);
            xh=round(x+rect);
            yl=round(y-rect);
            yh=round(y+rect);
            
            outof=0;
            if (xl<1) xl=1; outof=1; end
            if (yl<1) yl=1; outof=1; end
            if (xh>=2*wid) xh=2*wid-1; outof=1; end
            if (yh>=2*hei) yh=2*hei-1; outof=1; end

            xlr=round(xr-rectd);
            xhr=round(xr+rectd);
            ylr=round(yr-rectd);
            yhr=round(yr+rectd);
            
            if (xlr<1) xlr=1; end
            if (ylr<1) ylr=1; end
            if (xhr>=2*wid) xhr=tstsize-1; end
            if (yhr>=2*hei) yhr=tstsize-1; end

            
            a=sum(sum(double(img(yl:yh, xl:xh, 1, f))));  
            if (rect~=0) a=a/rect/rect/4; end
                
            if (xor(a<0.5, invert) && (outof==0)) 
                test(ylr:yhr, xlr:xhr, 1, f)=0;
                out(i+1, j+1, 1, f)=0;
            end
        
        end
        %print
        r='0b';
        for j=15:-1:0
            if (out(i+1, j+1, 1, f)==0)
                r=[r '1'];
            else
                r=[r '0'];
            end
        end
        fprintf (fid1, '%s', r);
        if (i~=255) fprintf (fid1, ','); end
        fprintf (fid1, '\n');
    end
    fprintf (fid1, '}');
    if (f~=frames) fprintf (fid1, ','); end
    fprintf (fid1, '\n');
    Frm(f)=im2frame(uint8(out(:,:,[1 1 1],f)));
end
fprintf (fid1, '};\n');
fclose(fid1);

figure(1);

imi=2;
subplot(221);
imshow(img(:,:,1,imi), [0 1]);

subplot(222);
imshow(test(:,:,1,imi), [0 1]);

subplot(212);
imshow(out(:,:,1,imi)', [0 1]);
title(['rect:' num2str(rect) '  rectd:' num2str(rectd)]);

figure(2);
for f=1:frames
    subplot(2,frames,f);
    imshow(img(:,:,1,f), [0 1]);

    subplot(2,frames,f+frames);
    imshow(test(:,:,1,f), [0 1]);
end
