#define F_CPU 8000000

#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "ani.h"
#include "digit.h"

#define ever (;;)

#define AXIAL 256
#define LIND_C 128

#define ledout(l) PORTC=(l), PORTD=(l)>>8, PORTB=( ((l)&0b11000000) | (((l)>>8)&0b00000111) )
#define SYNC (PIND&4)==0
#define FN (PIND&2)==0


// trvani jednotlivych obrazu [rotace]
//uint8_t ani_wait_seq[A_FRAMES]={5,5,5,5,5,5,5};		//walker
//uint8_t ani_wait_seq[A_FRAMES]={100,1,1,3,1,1};		//szem
uint8_t ani_wait_seq[A_FRAMES]={8,8,8,8,8,8};		//pacman

uint32_t l;
//uint16_t j, pix[AXIAL];		//obrazek v ram
uint16_t meas_a, meas[A_FRAMES], 	meas_a_tmp;		//pro mereni rychlosti otaceni
uint8_t lindex, anix=3;		//aktualni radek obrazku, aktualni frame animace
//char spd[16];	vypis cislic

uint16_t* pcpix;	//pointer zacatku aktualniho obrazu

int main(void) {
	OSCCAL=0xFF;

	DDRB=0b11111111;
	DDRC=0b11111111;
	DDRD=0b11111000;

	MCUCR|=0b00000011;	//INT0 ? edge
	GICR|=1<<INT0;

	TCCR0=0x01;		//T0 Presc=1
	TIMSK|= (1<<TOIE0) + (1<<TOIE1);	//T0 & T1 OVF interrupt


	TCCR1A|= (1<<WGM10) + (1<<WGM11);
	TCCR1B|= (1<<WGM12) + (1<<WGM13);		//Fast PWM, OCR1A
	TCCR1B|= 1; 			//Presc=1

	
	//for (j=0; j<AXIAL; j++) pix[j]=0; //pgm_read_word(img0 + j);

	//inicializace
	pcpix=ani0[anix];		
  lindex=0;
	OCR1A=0xFFFF;
	TCNT0=0;
	TCNT1=0;
	sei();

  for ever {

	//	sprintf(spd, "%d %d", meas_a_tmp, meas);	
	//	wrdigits(pix+100, spd);
  }

}

// TDX - koeficient DP 1. radu pro mereni frekvence
#define TDX 2

ISR(INT0_vect){					//referencni bod na kruhu
	static uint8_t w;

	TCNT1=0;	//nove mereni
	TCNT0=0;
	meas_a_tmp=meas_a;		//pocet taktu za otoceni
	meas_a=0;
	lindex=LIND_C;	//zacatek zobrazeni

	sei();	//dalsi cast jiz nemusi byt presne casovana

	//DP a ulozeni
	OCR1A = meas[anix] = ((uint32_t)meas[anix]*(uint32_t)(TDX-1) + (uint32_t)meas_a_tmp ) / TDX;

	if (w==0) {		
		anix++;			//nasl. obraz animace
		if (anix==A_FRAMES) anix=0;

		w=ani_wait_seq[anix];		//koresp. hodnota casu trvani obr.
		pcpix=ani0[anix];			//ukazatel akt. obrazu
  } else w--;
}


ISR(TIMER0_OVF_vect) {			//mereni hodinovych cyklu
	meas_a++;
}


ISR(TIMER1_OVF_vect) {		// zobrazeni jednolivych radku

//		ledout(pix[lindex]);	//cteni z ram
		ledout(pgm_read_word(pcpix + lindex));	//cteni z pgm. pameti
		lindex++;			//nasl. radek
		if (lindex==AXIAL) lindex=0;
}

